/****************************************************************************/
/* Copyright(C) : Advantech Technologies, Inc.														 */
/* Create Date  : 2015/03/06 by Eric Liang															     */
/* Modified Date: 2015/03/06 by Eric Liang															 */
/* Abstract     : IoTSensors_Handler                                     										*/
/* Reference    : None																									 */
/****************************************************************************/
//#include <stdbool.h>
#include <stddef.h>
#include "platform.h"
#include "susiaccess_handler_api.h"
#include "wisepaas_02_def.h"
#include "IoTGWHandler.h"
#include "IoTGWFunction.h"
#include "inc/IoTGW_Def.h"
#include "common.h"
#include "SnGwParser.h"
#include "SnMJSONParser.h"

#include "BasicFun_Tool.h"
#include "DataTransform.h"
#include "cJSON.h"




#include <AdvJSON.h>


//-----------------------------------------------------------------------------
// Types and defines:
//-----------------------------------------------------------------------------
#define cagent_request_custom 2002
#define cagent_custom_action 30002
const char strPluginName[MAX_TOPIC_LEN] = {"DevMgt"};  // <DevMgt>
const int iRequestID = cagent_request_custom;
const int iActionID = cagent_custom_action;

//-----------------------------------------------------------------------------
// Internal Prototypes:
//-----------------------------------------------------------------------------
//
typedef struct{
   void* threadHandler;
   bool isThreadRunning;
}handler_context_t;

//-----------------------------------------------------------------------------
// Variables
//-----------------------------------------------------------------------------
static void* g_loghandle = NULL;
static bool g_bEnableLog = TRUE;
static char agentConfigFilePath[MAX_PATH] = {0};

static Handler_info  g_PluginInfo;
static handler_context_t g_HandlerContex;
//static HANDLER_THREAD_STATUS g_status = handler_no_init;
static bool m_bAutoReprot = false;
static time_t g_monitortime;
static HandlerSendCbf  g_sendcbf = NULL;										// Client Send information (in JSON format) to Cloud Server	
static HandlerSendCustCbf  g_sendcustcbf = NULL;						// Client Send information (in JSON format) to Cloud Server with custom topic	
static HandlerSubscribeCustCbf g_subscribecustcbf = NULL;
static HandlerAutoReportCbf g_sendreportcbf = NULL;				// Client Send report (in JSON format) to Cloud Server with AutoReport topic
static HandlerSendCapabilityCbf g_sendinfospeccbf = NULL;		

// <DevMgt>
static int g_nDevNum = 2;
static const char *g_szCapability = "{\"DevMgt\":{\"Info\":{\"e\":[{\"n\":\"Name\",\"sv\":\"PLC_Mgt\",\"asm\":\"r\"},{\"n\":\"sw\",\"sv\":\"1.0.1\",\"asm\":\"r\"},{\"n\":\"reset\",\"u\":\"\",\"bv\":false,\"min\":false,\"max\":true,\"asm\":\"rw\"}],\"bn\":\"Info\"},\"ver\":1}}";


// Device Data - Sample code
static char *g_DemoDevID[2] = {"0077000E4C000011","0077000E4C000022"};
static char *g_szDevInfoSpec[2] = {"{\"PLC\":{\"SenData\":{\"e\":[{\"n\":\"temperature\",\"v\":46.2,\"asm\":\"r\"},{\"n\":\"version\",\"sv\":\"2.1.2\",\"asm\":\"r\"},{\"n\":\"reset\",\"u\":\"\",\"bv\":false,\"min\":false,\"max\":true,\"asm\":\"rw\"}],\"bn\":\"SenData\"},\"ver\":1}}",\
                                                                "{\"PLC\":{\"SenData\":{\"e\":[{\"n\":\"Hue\",\"v\":76,\"asm\":\"r\"},{\"n\":\"version\",\"sv\":\"2.1.2\",\"asm\":\"r\"},{\"n\":\"reset\",\"u\":\"\",\"bv\":false,\"min\":false,\"max\":true,\"asm\":\"rw\"}],\"bn\":\"SenData\"},\"ver\":1}}"}; 

static char *g_szDevData1[2] = {"{\"PLC\":{\"SenData\":{\"e\":[{\"n\":\"temperature\",\"v\":51}],\"bn\":\"SenData\"},\"ver\":1}}",\
                                                           "{\"PLC\":{\"SenData\":{\"e\":[{\"n\":\"Hue\",\"v\":66}],\"bn\":\"SenData\"},\"ver\":1}}"};

static char *g_szDevData2[2] = { "{\"PLC\":{\"SenData\":{\"e\":[{\"n\":\"temperature\",\"v\":38}],\"bn\":\"SenData\"},\"ver\":1}}",\
                                                            "{\"PLC\":{\"SenData\":{\"e\":[{\"n\":\"Hue\",\"v\":72}],\"bn\":\"SenData\"},\"ver\":1}}"};


CRITICAL_SECTION g_SendDevCriticalSec;
CRITICAL_SECTION g_SendDevMgtCriticalSec;
//static CAGENT_PTHREAD_ENTRY(ThreadSetValue, args);

// Device


static Handler_info  g_DevPluginInfo[MAX_DEVICE];  
static cagent_agent_info_body_t g_DevAgentInfo[MAX_DEVICE];
static cagent_agent_info_body_t g_gw;



// IoTGW 
static char* GetCapability( );

int runing = 1;


//-----------------------------------------------------------------------------
// Function:
//-----------------------------------------------------------------------------

void update_sendata(void *arg);
static int SendMsgToSUSIAccess(  const char* Data, unsigned int const DataLen, void *pRev1, void* pRev2 );

//#ifdef _MSC_VER
//BOOL WINAPI DllMain(HINSTANCE module_handle, DWORD reason_for_call, LPVOID reserved)
//{
//	if (reason_for_call == DLL_PROCESS_ATTACH) // Self-explanatory
//	{
//		printf("DllInitializer\r\n");
//		DisableThreadLibraryCalls(module_handle); // Disable DllMain calls for DLL_THREAD_*
//		if (reserved == NULL) // Dynamic load
//		{
//			// Initialize your stuff or whatever
//			// Return FALSE if you don't want your module to be dynamically loaded
//		}
//		else // Static load
//		{
//			// Return FALSE if you don't want your module to be statically loaded
//			return FALSE;
//		}
//	}
//
//	if (reason_for_call == DLL_PROCESS_DETACH) // Self-explanatory
//	{
//		printf("DllFinalizer\r\n");
//		if (reserved == NULL) // Either loading the DLL has failed or FreeLibrary was called
//		{
//			// Cleanup
//			Handler_Uninitialize();
//		}
//		else // Process is terminating
//		{
//			// Cleanup
//			Handler_Uninitialize();
//		}
//	}
//	return TRUE;
//}
//#else
//__attribute__((constructor))
///**
// * initializer of the shared lib.
// */
//static void Initializer(int argc, char** argv, char** envp)
//{
//    printf("DllInitializer\r\n");
//}
//
//__attribute__((destructor))
///** 
// * It is called when shared lib is being unloaded.
// * 
// */
//static void Finalizer()
//{
//    printf("DllFinalizer\r\n");
//	Handler_Uninitialize();
//}
//#endif

void Handler_CustMessageRecv(char * const topic, void* const data, const size_t datalen, void *pRev1, void* pRev2)
{
	printf(" %s> Topic:%s, Data:%s\r\n", strPluginName, topic, (char*)data);
}


// <DevMgt>
static CAGENT_PTHREAD_ENTRY(ThreadDevConnect, args)
{
	int i=0;
	int len = 0;
	Handler_info  *pDevHander = NULL;
	char buffer[MAX_BUFFER_SIZE]={0};


	//Send DevMgt Capability
	if( g_sendinfospeccbf ) {
		char* newData = Trans2NewFrom(g_szCapability);
		if(newData)
		{
			g_sendinfospeccbf(&g_PluginInfo, newData, strlen(newData), NULL, NULL);
			free(newData);
		}
	}	

	PRINTF("Start send Device connect message\r\n");
	for( i = 0; i< MAX_DEVICE ; i ++ ) {
		if(g_DevAgentInfo[i].status == 1)
		{
			pDevHander = &g_DevPluginInfo[i];

			// 3. Register to WISECloud
			PRINTF("Send SenHub %s\r\n", pDevHander->agentInfo->hostname);
			DeviceConnectToWISECloud( pDevHander );
			SendInfoSpec_SenHub( g_szDevInfoSpec[i], strlen(g_szDevInfoSpec[i]), pDevHander, NULL );
		}
	}
	PRINTF("Finish send SenHub connect message\r\n");
	app_os_thread_exit(0);
	return 0;
}

/* **************************************************************************************
 *  Function Name: Handler_Initialize
 *  Description: Init any objects or variables of this handler
 *  Input :  PLUGIN_INFO *pluginfo
 *  Output: None
 *  Return:  0  : Success Init Handler
 *              -1 : Fail Init Handler
 * ***************************************************************************************/
int HANDLER_API Handler_Initialize( HANDLER_INFO *pluginfo )
{
	if( pluginfo == NULL )
		return handler_fail;
	// <DevMgt> for debug using
	//while(1)
	//{
	//	int i;
	//	i=0;
	//}
	// 1. Topic of this handler
	snprintf( pluginfo->Name, sizeof(pluginfo->Name), "%s", strPluginName );
	pluginfo->RequestID = iRequestID;
	pluginfo->ActionID = iActionID;
	printf(" >Name: %s\n\r\n", strPluginName);
	// 2. Copy agent info 
	memcpy(&g_PluginInfo, pluginfo, sizeof(HANDLER_INFO));
	g_PluginInfo.agentInfo = pluginfo->agentInfo;

	if(g_bEnableLog)
	{
		g_loghandle = pluginfo->loghandle;
	}

	// 3. Callback function -> Send JSON Data by this callback function
	g_sendcbf = g_PluginInfo.sendcbf = pluginfo->sendcbf;
	g_sendreportcbf = g_PluginInfo.sendreportcbf = pluginfo->sendreportcbf;


	g_sendinfospeccbf =g_PluginInfo.sendcapabilitycbf = pluginfo->sendcapabilitycbf;

	g_sendcustcbf = g_PluginInfo.sendcustcbf = pluginfo->sendcustcbf;
	g_subscribecustcbf = g_PluginInfo.subscribecustcbf = pluginfo->subscribecustcbf;

	g_HandlerContex.threadHandler = NULL;
	g_HandlerContex.isThreadRunning = false;
	//g_status = handler_init;


	// <Eric>
	if( InitDevMgtHandler() < 0 )
		return handler_fail;

	return handler_success;
}

/* **************************************************************************************
 *  Function Name: Handler_Uninitialize
 *  Description: Release the objects or variables used in this handler
 *  Input :  None
 *  Output: None
 *  Return:  void
 * ***************************************************************************************/
void Handler_Uninitialize()
{
	g_sendcbf = NULL;
	g_sendcustcbf = NULL;
	g_sendreportcbf = NULL;
	g_sendinfospeccbf = NULL;
	g_subscribecustcbf = NULL;
	

	app_os_DeleteCriticalSection(&g_SendDevCriticalSec);
	app_os_DeleteCriticalSection(&g_SendDevMgtCriticalSec);
}

/* **************************************************************************************
 *  Function Name: Handler_Get_Status
 *  Description: Get Handler Threads Status. CAgent will restart current Handler or restart CAgent self if busy.
 *  Input :  None
 *  Output: char * : pOutStatus       // cagent handler status
 *  Return:  handler_success  : Success Init Handler
 *			 handler_fail : Fail Init Handler
 * **************************************************************************************/
int HANDLER_API Handler_Get_Status( HANDLER_THREAD_STATUS * pOutStatus )
{
	*pOutStatus = handler_status_start;
	return handler_success;
/*
	int iRet = handler_fail; 

	if(!pOutStatus) return iRet;

	switch (g_status)
	{
	default:
	case handler_no_init:
	case handler_init:
	case handler_stop:
		*pOutStatus = g_status;
		break;
	case handler_start:
	case handler_busy:
		{
			time_t tv;
			time(&tv);
			if(difftime(tv, g_monitortime)>5)
				g_status = handler_busy;
			else
				g_status = handler_busy;
			*pOutStatus = g_status;
		}
		break;
	}
	
	iRet = handler_success;
	return iRet;
*/
}

/* **************************************************************************************
 *  Function Name: Handler_OnStatusChange
 *  Description: Agent can notify handler the status is changed.
 *  Input :  PLUGIN_INFO *pluginfo
 *  Output: None
 *  Return:  None
 * ***************************************************************************************/
void HANDLER_API Handler_OnStatusChange( HANDLER_INFO *pluginfo )
{
	int i=0;
    void* threadHandler;

	printf(" %s> Update Status\r\n", strPluginName);
	if(pluginfo)
		memcpy(&g_PluginInfo, pluginfo, sizeof(HANDLER_INFO));
	else
	{
		memset(&g_PluginInfo, 0, sizeof(HANDLER_INFO));
		snprintf( g_PluginInfo.Name, sizeof( g_PluginInfo.Name), "%s", strPluginName );
		g_PluginInfo.RequestID = iRequestID;
		g_PluginInfo.ActionID = iActionID;
	}
	if(pluginfo->agentInfo->status == 1)
	{
		if (app_os_thread_create(&threadHandler, ThreadDevConnect, NULL) == 0)
		{
			app_os_thread_detach(threadHandler);
		}
	}
}

/* **************************************************************************************
 *  Function Name: Handler_Start
 *  Description: Start Running
 *  Input :  None
 *  Output: None
 *  Return:  0  : Success Init Handler
 *              -1 : Fail Init Handler
 * ***************************************************************************************/
int HANDLER_API Handler_Start( void )
{
	printf("> %s Handler_Start\r\n", strPluginName);
	//if (app_os_thread_create(&g_HandlerContex.threadHandler, SampleHandlerThreadStart, &g_HandlerContex) != 0)
	//{
	//	g_HandlerContex.isThreadRunning = false;
	//	printf("> start handler thread failed!\r\n");	
	//	return handler_fail;
 //   }
	g_HandlerContex.isThreadRunning = true;
	//g_status = handler_start;
	time(&g_monitortime);

	StartDevHandler();
	return handler_success;
}


/* **************************************************************************************
 *  Function Name: Handler_Stop
 *  Description: Stop the handler
 *  Input :  None
 *  Output: None
 *  Return:  0  : Success Init Handler
 *              -1 : Fail Init Handler
 * ***************************************************************************************/
int HANDLER_API Handler_Stop( void )
{
	if(g_HandlerContex.isThreadRunning == true)
	{
		g_HandlerContex.isThreadRunning = false;
		//app_os_thread_join(g_HandlerContex.threadHandler);
		g_HandlerContex.threadHandler = NULL;
	}
	//g_status = handler_stop;

	// <Eric>
	StopSNGWHandler();
	return handler_success;
}

/* **************************************************************************************
 *  Function Name: Handler_Recv
 *  Description: Receive Packet from MQTT Server
 *  Input : char * const topic, 
 *			void* const data, 
 *			const size_t datalen
 *  Output: void *pRev1, 
 *					void* pRev2
 *  Return: None
 * ***************************************************************************************/
void HANDLER_API Handler_Recv(char * const topic, void* const data, const size_t datalen, void *pRev1, void* pRev2  )
{
	int cmdID = 0;
	int len = 0;
	char szSessionId[MAX_SIZE_SESSIONID]={0};
	char buffer[MAX_BUFFER_SIZE]={0};
	// Recv Remot Server Command to process
	PRINTF("%s>Recv Topic [%s] Data %s\r\n", strPluginName, topic, (char*) data );

	if(!ParseReceivedData(data, datalen, &cmdID,szSessionId,sizeof(szSessionId)))
		return;

	PRINTF("Cmd ID=%d\r\n",cmdID);
	switch (cmdID)
	{
	case IOTGW_GET_CAPABILITY_REQUEST:
	case IOTGW_HANDLER_GET_CAPABILITY_REQUEST:
		{			
			// <DevMgt>
			char *pszCapability = NULL;
			pszCapability = GetCapability();
			if( pszCapability != NULL ) {
				g_sendcbf(&g_PluginInfo, cmdID+1, pszCapability, strlen( pszCapability )+1, NULL, NULL);
				{
					void* threadHandler;
					if (app_os_thread_create(&threadHandler, ThreadDevConnect, NULL) == 0)
					{
						app_os_thread_detach(threadHandler);
					}
				}
			} else {
				g_sendcbf(&g_PluginInfo, IOTGW_ERROR_REPLY, g_szCapability, strlen( g_szCapability )+1, NULL, NULL);
			}
		}
		break;
	case IOTGW_GET_SENSOR_REQUEST:
		{
			// { "sessionID":"XXX", "sensorInfoList":{"e":[{"n":"WSN/0000852CF4B7B0E8/Info/Health","v":80,"StatusCode":200}]} }
			PRINTF("IOTGW_GET_SENSOR_REQUEST data=%s\r\n",data );			
			len = ProcGetInterfaceValue(szSessionId, data, buffer, sizeof(buffer));
			PRINTF("len=%d Ret=%s\r\n",len,buffer);
			if( len > 0 )
				g_sendcbf(&g_PluginInfo,IOTGW_GET_SENSOR_REPLY, buffer, len+1, NULL, NULL);
		}
		break;
	case IOTGW_SET_SENSOR_REQUEST:
		{
			// { "sessionID":"XXX", "sensorInfoList":{"e":[{"n":"WSN/0000852CF4B7B0E8/Info/Health","v":80,"StatusCode":200}]} }
			// <DevMgt>
			PRINTF("IOTGW_SET_SENSOR_REQUEST data=%s\r\n",data );			

		}
		break;
	default:
		{
			PRINTF("Unknow CMD ID=%d\r\n", cmdID );
			/*  {"sessionID":"1234","errorRep":"Unknown cmd!"}  */
			if(strlen(szSessionId)>0)
				snprintf(buffer, sizeof(buffer), "{\"%s\":\"%s\",\"sessionID\":\"%s\"}", SN_ERROR_REP, "Unknown cmd!", szSessionId);
			else
				snprintf(buffer, sizeof(buffer), "{\"%s\":\"%s\"}", SN_ERROR_REP, "Unknown cmd!");
			g_sendcbf(&g_PluginInfo, IOTGW_ERROR_REPLY, buffer, strlen(buffer)+1, NULL, NULL);
			break;
		}
		break;
	}
}

/* **************************************************************************************
 *  Function Name: Handler_AutoReportStart
 *  Description: Start Auto Report
 *  Input : char *pInQuery
 *  Output: char * pOutReply
 *  Return: None
 * ***************************************************************************************/
void HANDLER_API Handler_AutoReportStart(char *pInQuery)
{
	/*{"susiCommData":{"catalogID":4,"autoUploadIntervalSec":30,"requestID":1001,"requestItems":["all"],"commCmd":2053,"type":"WSN"}}*/
	/*TODO: Parsing received command*/
	m_bAutoReprot = true;
}

/* **************************************************************************************
 *  Function Name: Handler_AutoReportStop
 *  Description: Stop Auto Report
 *  Input : None
 *  Output: None
 *  Return: None
 * ***************************************************************************************/
void HANDLER_API Handler_AutoReportStop(char *pInQuery)
{
	/*TODO: Parsing received command*/
	m_bAutoReprot = false;
}

/* **************************************************************************************
 *  Function Name: Handler_Get_Capability
 *  Description: Get Handler Information specification. 
 *  Input :  None
 *  Output: char * : pOutReply       // JSON Format
 *  Return:  int  : Length of the status information in JSON format
 *                :  0 : no data need to trans
 * **************************************************************************************/
int HANDLER_API Handler_Get_Capability( char ** pOutReply ) // JSON Format
{
	int len = 0; // Data length of the pOutReply 
	char *pBuffer = NULL;

	PRINTF("\r\n\r\n");
	PRINTF("DevMgt Handler_Get_Capability\r\n");

    pBuffer = g_szCapability;
    if( pBuffer ) {
			len = strlen( pBuffer );
			*pOutReply = (char *)malloc(len + 1);
			memset(*pOutReply, 0, len + 1);
			strcpy(*pOutReply, pBuffer);
			{
				void* threadHandler;
				if (app_os_thread_create(&threadHandler, ThreadDevConnect, NULL) == 0)
				{
					app_os_thread_detach(threadHandler);
				}
			}
	} // End of pBuffer


	return len;
}

/* **************************************************************************************
 *  Function Name: Handler_MemoryFree
 *  Description: free the mamory allocated for Handler_Get_Capability
 *  Input : char *pInData.
 *  Output: None
 *  Return: None
 * ***************************************************************************************/
void HANDLER_API Handler_MemoryFree(char *pInData)
{
	if(pInData)
	{
		free(pInData);
		pInData = NULL;
	}
}

static char* GetCapability( )
{
	return g_szCapability;
}




/****************************************************************************/
/* Below Functions are IoTGW Handler source code                   			 */
/****************************************************************************/

static int Register_Device( void **pOutParam, DevInfo *pRev1 );

static int Disconnect_Dev( void *pOutParam );

static int SendInfoSpec_SenHub( const char *pInJson, const int InDataLen, void *pOutParam, void *pRev1 );

static int AutoReportSenData_SenHub( const char *pInJson, const int InDataLen, void *pOutParam, void *pRev1 );




static int SendMsgToSUSIAccess(  const char* Data, unsigned int const DataLen, void *pRev1, void* pRev2 )
{
		int iRet = 0;
		if( g_sendreportcbf ) {
			g_sendreportcbf( &g_PluginInfo, Data, strlen(Data), pRev1, pRev2);
			iRet = 1;
		}
	return iRet;
}


// topic: /cagent/admin/%s/agentcallbackreq
static void HandlerCustMessageRecv(char * const topic, void* const data, const size_t datalen, void *pRev1, void* pRev2)
{
	int cmdID = 0;
	char newSenHubUID[MAX_SN_UID]={0};
	char oldSenHubUID[MAX_SN_UID]={0};
	char buffer[MAX_BUFFER_SIZE]={0};
	char Topic[MAX_TOPIC_SIZE]={0};
	char szSessionId[MAX_SIZE_SESSIONID]={0};
	int index = -1;
	int len = 0;
	Handler_info  *pDevHander = NULL;
	Handler_info  SenHubHandler;

	int i = 0;
	// Recv Remot Server Command to process
	//PRINTF(" %s>Recv Cust Topic [%s] Data %s\r\n", strPluginName, topic, (char*) data );

	if(!ParseReceivedData(data, datalen, &cmdID,szSessionId,sizeof(szSessionId))) {
		PRINTF(" Can't find cmdID\r\n" );
		return;
	}
	/*if( GetSenHubUIDfromTopic( transTopic, SenHubUID, sizeof(SenHubUID) ) == 0 ) {
		PRINTF(" Can't find SenHubID Topic=%s\r\n",topic );
		return;
	}*/
	if(!GetNewIDFromTopic(topic, newSenHubUID))
	{
		PRINTF(" Can't find SenHubID Topic=%s\r\n", topic );
		return;
	}
	GetOldID(newSenHubUID, oldSenHubUID);
	if( ( index = GetSenHubAgentInfobyUID(&g_DevAgentInfo, MAX_DEVICE, newSenHubUID) ) == -1 ) {
		PRINTF(" Can't find SenHub UID in Table =%s\r\n",newSenHubUID );
		return;
	}

	pDevHander = &g_DevPluginInfo[index];

	if( pDevHander ) {
		memset(&SenHubHandler,0,sizeof(SenHubHandler));
		memcpy(&SenHubHandler,pDevHander, sizeof(SenHubHandler));
		snprintf(SenHubHandler.Name,MAX_TOPIC_LEN, "%s", SENHUB_HANDLER_NAME); // "SenHub"
		pDevHander = &SenHubHandler;
	} else 
		return;
	// "/cagent/admin/%s/agentinfoack"
	memset(Topic,0,sizeof(Topic));
	snprintf(Topic,sizeof(Topic), DEF_AGENTACT_TOPIC, g_PluginInfo.agentInfo->productId, newSenHubUID );
		
	PRINTF("HandlerCustMessageRecv Cmd =%d\r\n",cmdID);

	switch (cmdID)
	{
	case IOTGW_GET_CAPABILITY_REQUEST:
		{
			// <DevMgt> need get device infospec 
			char* newData = NULL;
			int devIndex = 0;
			for(i=0;i < g_nDevNum; i++ )
			{
				if( strstr(g_DemoDevID[i], oldSenHubUID ) )
				{
					devIndex = i;
					break;
				}
			}
			newData = Trans2NewFrom(g_szDevInfoSpec[devIndex]);
			if(newData)
			{
				if( len > 0 )
					g_sendcustcbf(pDevHander,IOTGW_GET_CAPABILITY_REPLY, Topic, newData, strlen(newData)+1 , NULL, NULL);
			
				free(newData);
			}
			else
			{
				PRINTF("IOTGW_GET_CAPABILITY_REQUEST: Data Transform failed!\r\n");
			}
		}
		break;
	case IOTGW_GET_SENSOR_REQUEST:
		{
			// { "sessionID":"XXX", "sensorInfoList":{"e":[{"n":"SenData/dout","bv":1,"StatusCode":200}]} }	

			len = ProcGetSenHubValue(oldSenHubUID, szSessionId, data, buffer, sizeof(buffer));
			if( len > 0 )
			{
				char* newData = NULL;
				newData = Trans2NewFrom(buffer);
				if(newData)
				{
					if( len > 0 )
						g_sendcustcbf(pDevHander,IOTGW_GET_SENSOR_REPLY, Topic, newData, strlen(newData)+1 , NULL, NULL);
				
					free(newData);
				}
				else
				{
					PRINTF("IOTGW_GET_SENSOR_REQUEST: Data Transform failed!\r\n");
				}
			}
		}
		break;
	case IOTGW_SET_SENSOR_REQUEST:
		{
			// { "sessionID":"XXX", "sensorInfoList":{"e":[ {"n":"SenData/dout", "sv":"Setting", "StatusCode": 202 } ] } }
			// { "sessionID":"XXX", "sensorInfoList":{"e":[{"n":"SenData/din","sv":"Read Only","StatusCode":405} ] } }
			// <DevMgt>
			PRINTF("IOTGW_SET_SENSOR_REQUEST data=%s\r\n",data );
		}
		break;
	default:
		{
			char* newData = NULL;
			PRINTF("Unknow CMD ID=%d\r\n", cmdID );
			/*  {"sessionID":"1234","errorRep":"Unknown cmd!"}  */
			if(strlen(szSessionId)>0)
				snprintf(buffer, sizeof(buffer), "{\"%s\":\"%s\",\"sessionID\":\"%s\"}", SN_ERROR_REP, "Unknown cmd!", szSessionId);
			else
				snprintf(buffer, sizeof(buffer), "{\"%s\":\"%s\"}", SN_ERROR_REP, "Unknown cmd!");
			
			newData = Trans2NewFrom(buffer);
			if(newData)
			{
				g_sendcustcbf(pDevHander,IOTGW_ERROR_REPLY, Topic, newData, strlen(newData)+1 , NULL, NULL);			
				free(newData);
			}
			else
			{
				PRINTF("Unknow CMD: Data Transform failed!\r\n");
			}
		}
		break;
	}
}


int DeviceConnectToWISECloud( Handler_info *pDevHandler)
{
	char Topic[DEF_MAX_STRING_LENGTH]={0};
	char JSONData[MAX_FUNSET_DATA_SIZE]={0};
	int   datalen = 0;
	int   rc = 1;
	char newID[DEF_DEVID_LENGTH] = {0};
	char parentId[DEF_DEVID_LENGTH] = {0};

	app_os_EnterCriticalSection(&g_SendDevCriticalSec);

	if(strlen(pDevHandler->WorkDir) > 0 )
		snprintf(parentId,sizeof(parentId),"%s",pDevHandler->WorkDir);
	else
		snprintf(parentId,sizeof(parentId),"%s",g_PluginInfo.agentInfo->devId);
	
	datalen = GetAgentInfoData(JSONData,sizeof(JSONData),pDevHandler, parentId);

	if(datalen <20 )
		rc = 0;

	// 1. Subscribe Topic2 -> Create SenHub <-> WISECloud communication channel
	snprintf( Topic, sizeof(Topic), DEF_CALLBACKREQ_TOPIC, pDevHandler->agentInfo->productId, pDevHandler->agentInfo->devId);

	if( g_subscribecustcbf )
		g_subscribecustcbf( Topic, &HandlerCustMessageRecv );		
	PRINTF("Subscribe Dev Topic:%s \n", Topic);

	// 2. SendAgentInfo online
	memset(Topic,0,sizeof(Topic));
	snprintf(Topic,sizeof(Topic),DEF_INFOACK_TOPIC, pDevHandler->agentInfo->devId);
	if( g_sendcustcbf )
	{
		if( g_sendcustcbf )
			g_sendcustcbf(pDevHandler,1,Topic,JSONData, datalen, NULL, NULL);
	}
	PRINTF("Send Dev AgentInfo:%s \n", JSONData);
	app_os_LeaveCriticalSection(&g_SendDevCriticalSec);

	return rc;

}
int DeviceDisconnectWISECloud( Handler_info *pDevHandler)
{
	char Topic[MAX_TOPIC_SIZE]={0};
	char JSONData[MAX_FUNSET_DATA_SIZE]={0};
	int   datalen = 0;
	int   rc = 1;
	char newID[DEF_DEVID_LENGTH] = {0};

	memset(Topic,0,sizeof(Topic));
	snprintf(Topic,sizeof(Topic),DEF_INFOACK_TOPIC, pDevHandler->agentInfo->devId);

	datalen = GetAgentInfoData(JSONData,sizeof(JSONData),pDevHandler, g_PluginInfo.agentInfo->devId);

	if(datalen <20 )
		rc = 0;

	if( g_sendcustcbf )
		g_sendcustcbf(pDevHandler,1,Topic,JSONData, datalen, NULL, NULL);
	else 
		rc = 0;

	return rc;
}

// <DevMgt>
int GetDevInfo( int i, DevInfo *pDevInfo )
{
	int rc = 0;
	// Get PLC Device Info
	
	// 1. Unique ID in 16 character
	sprintf(pDevInfo->sUID, "%s", g_DemoDevID[i]);
	// 2. Product
	sprintf(pDevInfo->sProduct, "PLC");
	// 3. HostName
	sprintf(pDevInfo->sHostName,"PLC-%d", i );

	rc = 1;
	return rc;
}


// <DevMgt>
static CAGENT_PTHREAD_ENTRY(ThreadDevInfo, args)
{
	int i=0;
	int len = 0;
	int index = 0;
	char newID[128]={0};
	DevInfo devInfo;
	Handler_info *pHandler_info = NULL;


	// 1. Send DevMgt Capability
	app_os_EnterCriticalSection(&g_SendDevMgtCriticalSec);
	if( g_sendinfospeccbf ) {
		char* newData = Trans2NewFrom(g_szCapability);
		if(newData)
		{
			g_sendinfospeccbf(&g_PluginInfo, newData, strlen(newData), NULL, NULL);
			free(newData);
		}
	}		
	app_os_LeaveCriticalSection(&g_SendDevMgtCriticalSec);


	// 2. Update DevMgt Data 
	if( g_sendreportcbf )
		g_sendreportcbf( &g_PluginInfo, g_szCapability, strlen(g_szCapability), NULL, NULL );

	memset(&devInfo,0,sizeof(devInfo));


	for( i = 0; i<g_nDevNum;i++)
	{
// 3. Send all Device Connect Info 
		GetDevInfo(i, &devInfo);
		
		Register_Device( &pHandler_info, &devInfo );
	
		memset(&devInfo,0,sizeof(devInfo));

// 4. Send all device capability
		SendInfoSpec_SenHub( g_szDevInfoSpec[i], strlen(g_szDevInfoSpec[i]), pHandler_info, NULL );
		pHandler_info = NULL;
	}


	while(runing)
	{
// 5. Auto Report device data -> You must define your app's behavior : 
//     For example:  To check: What devices value are changing?  If yes -> update to data struct and send to cloud

		for (i =0; i < g_nDevNum; i++ )
		{
			GetNewID(g_DemoDevID[i], newID);

			if( ( index = GetSenHubAgentInfobyUID(&g_DevAgentInfo, MAX_DEVICE, newID) ) == -1 ) {
				PRINTF(" Can't find Device UID in Table =%s\r\n",newID );
				continue;
			}

			pHandler_info = &g_DevPluginInfo[index];

			//SendInfoSpec_SenHub( g_szDevInfoSpec[i], strlen(g_szDevInfoSpec[i]), pHandler_info, NULL );

			AutoReportSenData_SenHub( g_szDevData1[i], strlen(g_szDevData1[i]), pHandler_info, NULL );
			TaskSleep(5000);
			AutoReportSenData_SenHub( g_szDevData2[i], strlen(g_szDevData2[i]), pHandler_info, NULL );
			memset(newID,0,sizeof(newID));
			pHandler_info = NULL;
		}
	}


exit_wsn:


	app_os_thread_exit(0);
	return 0;
}



static int Register_Device( void **pOutParam, DevInfo *pDevInfo  )
{
	int rc = 0;
	int index = 0;
	char parentID[64]={0};
	char handlerName[32]={0};
	SenHubExInfo *pSenHubExInfo = (SenHubExInfo*)pDevInfo->pExtened;	
	Handler_info  *pDevHander = NULL;


	if( pDevInfo == NULL ) {
		PRINTF("SenHub is NULL\r\n");
		return rc;
	}

	// 1. Find empty SenHub Array
	if(  (index = GetUsableIndex(&g_DevAgentInfo, MAX_DEVICE ) )  == -1 ) 
	{
		PRINTF("GW Handler is Full \r\n");
		return rc;
	}

	pDevHander = &g_DevPluginInfo[index];
	*pOutParam    = &g_DevPluginInfo[index];

	// Assign ParentID
	if( pSenHubExInfo != NULL )
	{
		snprintf(parentID, sizeof(parentID),"%s",pSenHubExInfo->szParentID);
		GetNewID(pSenHubExInfo->szParentID, parentID);
		snprintf(handlerName, sizeof(handlerName),"%s",pSenHubExInfo->szHandlerName);
	}
	else // default
	{
		snprintf(parentID, sizeof(parentID),"");
		snprintf(handlerName, sizeof(handlerName),"SenHub");		
	}

	// 2. Prepare Sensor Node Handler_info data
	PackSenHubPlugInfo( pDevHander, &g_PluginInfo, pDevInfo->sUID, pDevInfo->sHostName, pDevInfo->sProduct, 1 ,handlerName, parentID );

	// 3. Register to WISECloud
	rc = DeviceConnectToWISECloud( pDevHander );
	

	return rc;
}

static int Disconnect_Dev( void *pInParam )
{
	int rc = 0;
	Handler_info *pHandler_info = (Handler_info*)pInParam;
	if( pHandler_info == NULL )  {
		PRINTF("[Disconnect_Dev]: pOutParam is NULL\r\n");
		return rc;
	}

	pHandler_info->agentInfo->status = 0;
	rc = DeviceDisconnectWISECloud( pHandler_info );
	return rc;
}


static int SendInfoSpec_SenHub( const char *pInJson, const int InDataLen, void *pInParam, void *pRev1 )
{
	int rc = 0;

	Handler_info *pHandler_info = (Handler_info*)pInParam;

	if( pHandler_info == NULL ) return rc;


	if( g_sendinfospeccbf ) {
		g_sendinfospeccbf( pHandler_info, pInJson, InDataLen, NULL, NULL );
		rc = 1;
	}

	return rc;
}

static int AutoReportSenData_SenHub( const char *pInJson, const int InDataLen, void *pInParam, void *pRev1 )
{
	int rc = 0;

	Handler_info *pHandler_info = (Handler_info*)pInParam;

	if( pHandler_info == NULL ) return rc;

	if( g_sendreportcbf ) {
		g_sendreportcbf( pHandler_info, pInJson, InDataLen, NULL, NULL );
		rc = 1;
	}

	return rc;	
}







int InitDevMgtHandler()
{
	int rc = 0;
	int i = 0;


	// User can add its inint 


	// Allocate Handler_info array buffer point
	for( i = 0; i< MAX_DEVICE ; i ++ ) {
		memcpy(&g_DevPluginInfo[i],&g_PluginInfo,sizeof(Handler_info));
		memcpy(&g_DevAgentInfo[i],&g_PluginInfo.agentInfo,sizeof(cagent_agent_info_body_t));
		g_DevAgentInfo[i].status = 0;
		g_DevPluginInfo[i].agentInfo = &g_DevAgentInfo[i];
	}

	// Critical
	app_os_InitializeCriticalSection(&g_SendDevCriticalSec);
	app_os_InitializeCriticalSection(&g_SendDevMgtCriticalSec);


	rc = 1; 
	PRINTF("Success: Initial Sensor Network Handler\r\n");


	return rc;
}

int StartDevHandler()
{
	int rc = 0;
    void* threadHandler;
	
    if (app_os_thread_create(&threadHandler, ThreadDevInfo, NULL) == 0)
                  app_os_thread_detach(threadHandler);
	return rc;
}

int StopSNGWHandler()
{
	int rc = 0;

	while( runing )
		TaskSleep(100);

	return rc;
}



//-----------------------------------------------------------------------------
// UTIL Function:
//-----------------------------------------------------------------------------
#ifdef _MSC_VER
BOOL WINAPI DllMain( HINSTANCE module_handle, DWORD reason_for_call, LPVOID reserved )
{
	if ( reason_for_call == DLL_PROCESS_ATTACH ) // Self-explanatory
	{
		printf( "DllInitializer\n" );
		DisableThreadLibraryCalls( module_handle ); // Disable DllMain calls for DLL_THREAD_*
		if ( reserved == NULL ) // Dynamic load
		{
			// Initialize your stuff or whatever
			// Return FALSE if you don't want your module to be dynamically loaded
		}
		else // Static load
		{
			// Return FALSE if you don't want your module to be statically loaded
			return FALSE;
		}
	}

	if ( reason_for_call == DLL_PROCESS_DETACH ) // Self-explanatory
	{
		printf( "DllFinalizer\n" );
		if ( reserved == NULL ) // Either loading the DLL has failed or FreeLibrary was called
		{
			// Cleanup
			Handler_Uninitialize( );
		}
		else // Process is terminating
		{
			// Cleanup
			Handler_Uninitialize( );
		}
	}
	return TRUE;
}
#else
__attribute__( ( constructor ) )
/**
 * initializer of the shared lib.
 */
static void Initializer( int argc, char** argv, char** envp )
{
    printf( "DllInitializer\n" );
}

__attribute__( ( destructor ) )
/** 
 * It is called when shared lib is being unloaded.
 * 
 */
static void Finalizer( )
{
    printf( "DllFinalizer\n" );
	Handler_Uninitialize( );
}
#endif






